﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Net.Http;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Essentials;

namespace VatanBGS.Services
{
    public class BLL
    {
        private static string Url = "https://www.vatanbgs.com/Api/";


        public class HomePageViewModel : INotifyPropertyChanged
        {
            public event PropertyChangedEventHandler PropertyChanged;
            void onPropertyChanged([CallerMemberName] string propertyName = null)
            {
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
            }


            public HomePageViewModel()
            {
                TedadBag = 0;
            }


            public decimal Inventory { get; set; }
            public int MaxSelect { get; set; }
            public string NameFa { get; set; }
            public string NameEn { get; set; }
            public string NameEnSlug { get; set; }
            public string ImageName { get; set; }
            public string Title { get; set; }
            public string Alt { get; set; }
            public decimal? TotalPrice { get; set; }
            public int IdTypeDisplay { get; set; }
            public long ValueDisplay { get; set; }
            public long TotalPriceDisplay { get; set; }
            public int Rating { get; set; }
            public int IdProductHomePageType { get; set; }
            public bool IsNewProduct { get; set; }
            public bool IsAuction { get; set; }
            public bool IsSpecial { get; set; }
            public decimal IdProduct { get; set; }
            public decimal IdProductInventory { get; set; }



            int tedadBag;
            public int TedadBag
            {
                set
                {
                    tedadBag = value;
                    onPropertyChanged();
                }
                get => tedadBag;
            }

        }






        public async static Task<List<HomePageViewModel>> GetListProductHomePageSelect(int IdType = 0)
        {
            Guid IdCustomer = Guid.Parse("00000000-0000-0000-0000-000000000000");

            List<HomePageViewModel> mdl = new List<HomePageViewModel>();

            if (Connectivity.NetworkAccess != NetworkAccess.Internet)
            {
                return mdl;
            }


            try
            {
                var payload = new
                {
                    IdType = IdType,
                    IdCustomer = IdCustomer
                };

                var data = new StringContent(JsonConvert.SerializeObject(payload), Encoding.UTF8, "application/json");

                var client = new HttpClient
                {
                    Timeout = TimeSpan.FromMinutes(90)
                };

                HttpResponseMessage response = await client.PostAsync(Url + "GetListProductHomePageSelect", data);
                if (response.IsSuccessStatusCode)
                {
                    string result = await response.Content.ReadAsStringAsync();

                    mdl = JsonConvert.DeserializeObject<List<HomePageViewModel>>(result);
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine("\tERROR {0}", ex.Message);
            }

            return mdl;
        }
    }
}

