﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using VatanBGS.Services;
using Xamarin.Forms;
using Xamarin.Forms.Internals;
using static VatanBGS.Services.BLL;

namespace App15
{
    public class MyViewModel: INotifyPropertyChanged
    {
        public List<HomePageViewModel> Step1 { get; private set; } = new List<HomePageViewModel>();

        public MyViewModel()
        {
            Task.Run(() => MethosFillStep()).Wait();
        }


        private async Task<int> MethosFillStep()
        {
            Step1 = await BLL.GetListProductHomePageSelect(1);

            return 1;
        }

        bool isRefreshing;
        public bool IsRefreshing
        {
            get { return isRefreshing; }
            set
            {
                isRefreshing = value;
                OnPropertyChanged();
            }
        }


        public ICommand RefreshCommand => new Command(async () => await RefreshDataAsync());



        async Task RefreshDataAsync()
        {
            IsRefreshing = true;

           // Task.Run(() => MethosFillStep()).Wait();

            IsRefreshing = false;
        }


        #region INotifyPropertyChanged

        public event PropertyChangedEventHandler PropertyChanged;

        void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion

    }
}
